function main()
{

    if (logger.isLoggingEnabled) {
        logger.log("Args: " + url.templateArgs);
    }

    // Make sure the source node exists
    var sourceNodeRef = url.templateArgs.store_type + "://" + url.templateArgs.store_id + "/" + url.templateArgs.id;
    var sourceNode = search.findNode(sourceNodeRef);

    if (sourceNode === null) {
        status.code = 404;
        status.message = "Source node does not exist: " + sourceNodeRef;
        status.redirect = true;
        return;
    }

    if (json.has("associations")) {
        var associations = json.get("associations");
        if (logger.isLoggingEnabled) {
            logger.log("Associations: " + associations);
        }
        for (i = 0; i < associations.length(); i++) {
            var association = jsonUtils.toObject(associations.getJSONObject(i));
            var associationType = association.type;
            var targetNodeRef = association.targetNodeRef;
            if (logger.isLoggingEnabled) {
                logger.log("Assoc: " + associationType + ", target: " + targetNodeRef);
            }

            // Make sure the target node also exists
            var targetNode = search.findNode(targetNodeRef);
            if (targetNode === null) {
                status.code = 404;
                status.message = "Target node does not exist: " + targetNodeRef;
                status.redirect = true;
                return;
            }

            // And finally create the association if it does not exist
            if (!hasNamedTargetAssociation(sourceNode, targetNode, "lysedl:attachments")){
            	sourceNode.createAssociation(targetNode, associationType);
            }
        }
    }
    else {
        status.code = 400;
        status.redirect = true;
    }
}

function hasNamedTargetAssociation(node, targetNode, associationName){
	var assocs = node.assocs[associationName];
	
	if (assocs != null && assocs.length>0){
		for (var i = 0; i < assocs.length; i++){
			var assoc = assocs[i];
			if (assoc.nodeRef.toString().equals(targetNode.nodeRef.toString())){
			  return true;
			}
		}	
	}

	return false;
}


main();