<import resource="classpath:/alfresco/templates/webscripts/org/alfresco/repository/forms/pickerresults.lib.js">
//@overridden /alfresco/templates/webscripts/org/alfresco/repository/forms/pickerchildren.get.js

function main()
{
	var argsFilterType = args['filterType'],
	argsSelectableType = args['selectableType'],
	argsSearchTerm = args['searchTerm'],
	argsMaxResults = args['size'],
	argsXPath = args['xpath'],
	argsRootNode = args['rootNode'],
	pathElements = url.service.split("/"),
	parent = null,
	rootNode = null,
	results = [],
	categoryResults = null,
	resultObj = null,
	lastPathElement = null;

	if (logger.isLoggingEnabled()) {
		logger.log("children type = " + url.tchilemplateArgs.type);
		logger.log("argsSelectableType = " + argsSelectableType);
		logger.log("argsFilterType = " + argsFilterType);
		logger.log("argsSearchTerm = " + argsSearchTerm);
		logger.log("argsMaxResults = " + argsMaxResults);
		logger.log("argsXPath = " + argsXPath);
		logger.log("argsRootNode = " + argsRootNode);
	}

	try {
		// construct the NodeRef from the URL
		var nodeRef = url.templateArgs.store_type + "://" + url.templateArgs.store_id + "/" + url.templateArgs.id;
		
		// determine if we need to resolve the parent NodeRef
		if (argsXPath != null) {
			// resolve the provided XPath to a NodeRef
			var nodes = search.xpathSearch(argsXPath);
			if (nodes.length > 0) {
				nodeRef = String(nodes[0].nodeRef);
			}
		}

		// default to max of 1000 results
		var maxResults = 1000;
		if (argsMaxResults != null) {
			// force the argsMaxResults var to be treated as a number
			maxResults = parseInt(argsMaxResults, 10) || maxResults;
		}

		if (argsSelectableType === "dl:dataListItem") {
			parent = resolveNode(nodeRef);
			
			if (parent === null) {
				status.setCode(status.STATUS_NOT_FOUND, "Not a valid nodeRef: '" + nodeRef + "'");
				return null;
			}

			if (argsRootNode != null) {
				if(argsRootNode == "dataLists"){
					rootNode = resolveDatalistNode(nodeRef);
				}else{
					rootNode = resolveNode(argsRootNode) || companyhome;
				}
			}

			var ignoreTypes = null;
			if (argsFilterType != null) {
				if (logger.isLoggingEnabled()){
					logger.log("ignoring types = " + argsFilterType);
				}

				ignoreTypes = argsFilterType.split(',');
			}

			// retrieve the children of this node
			var childNodes = parent.childFileFolders(true, true, ignoreTypes, -1, maxResults, 0, "cm:name", true, null).getPage();
			
			// Ensure folders and folderlinks appear at the top of the list
			var containerResults = new Array(),
			contentResults = new Array();
			if(url.templateArgs.type === "hse" && parent.parent.properties["st:sitePreset"] == "civil-site")
			{
				childNodes.forEach(function(item)
				{
					if(item.properties["dl:dataListItemType"] == "lysedl:hseMeetingList")
					{
						//Filter out meeting datalist..
						return;
					}
          if (item.isContainer || item.type == "{http://www.alfresco.org/model/application/1.0}folderlink") {
            // wrap item and determine if it is selectable in the UI
            resultObj =
              {
                item: item
              };
            resultObj.selectable = isItemSelectable(item, argsSelectableType);
            containerResults.push(resultObj);
          } else {
            var qnamePaths = item.qnamePath.split("/"), container;
            if ((qnamePaths.length > 4) && (qnamePaths[2] == "st:sites"))
            {
              container = qnamePaths[4].substr(3);
            }
            // wrap item and determine if it is selectable in the UI
            resultObj =
              {
                item: item
              };
            resultObj.selectable = isItemSelectable(item, argsSelectableType);
            resultObj.container = container;
            contentResults.push(resultObj);
          }
				})
			}
			else if(url.templateArgs.type === "hse") {
			  for each (var result in childNodes) {
			    for each (var aspect in result.aspects) {
			      if(aspect == "{http://ns.lyse.no/model/1.0}isMeetingAspect" || aspect == "{http://ns.lyse.no/model/1.0}hseMeetingCommonPropertiesAspect"){
			        if (result.isContainer || result.type == "{http://www.alfresco.org/model/application/1.0}folderlink") {
			          // wrap result and determine if it is selectable in the UI
			          resultObj = 
			          { 
			              item: result
			          };
			          resultObj.selectable = isItemSelectable(result, argsSelectableType);
			          containerResults.push(resultObj);
			        } else {
			          var qnamePaths = result.qnamePath.split("/"), container;
			          if ((qnamePaths.length > 4) && (qnamePaths[2] == "st:sites"))
			          {
			            container = qnamePaths[4].substr(3);
			          }
			          // wrap result and determine if it is selectable in the UI
			          resultObj = 
			          { 
			              item: result
			          };
			          resultObj.selectable = isItemSelectable(result, argsSelectableType);
			          resultObj.container = container;
			          contentResults.push(resultObj);
			        }
			        break;
			      }
			    }
			  }
			} else if(url.templateArgs.type === "mcc-packages") {
			  for each (var result in childNodes) {
			    if(result.properties["name"] === "Commissioning packages") {
			      // Get the items from the datalist
			      var items = result.childFileFolders(true, true, ignoreTypes, -1, maxResults, 0, "cm:name", true, null).getPage();
			      for each (var item in items) {
			        if((item.type == "{http://ns.lyse.no/model/datalist/1.0}mccCommissioningPackages") && item.properties["lyse:mccCommissioningPackagesStatus"] == "start") {
			          if (item.isContainer || item.type == "{http://www.alfresco.org/model/application/1.0}folderlink") {
			            // wrap result and determine if it is selectable in the UI
			            resultObj = 
			            { 
			                item: item
			            };
			            resultObj.selectable = isItemSelectable(item, argsSelectableType);
			            containerResults.push(resultObj);
			          } else {
			            var qnamePaths = item.qnamePath.split("/"), container;
			            if ((qnamePaths.length > 4) && (qnamePaths[2] == "st:sites"))
			            {
			              container = qnamePaths[4].substr(3);
			            }
			            // wrap result and determine if it is selectable in the UI
			            resultObj = 
			            { 
			                item: item
			            };
			            resultObj.selectable = isItemSelectable(item, argsSelectableType);
			            resultObj.container = container;
			            contentResults.push(resultObj);
			          }
			        }
			      }
			    }
			  }
			} else if(url.templateArgs.type === "mcc-commissioning-packages") {
			  for each (var result in childNodes) {
			    if(result.properties["name"] === "MC packages") {
			      // Get the items from the datalist
			      var items = result.childFileFolders(true, true, ignoreTypes, -1, maxResults, 0, "cm:name", true, null).getPage();
			      for each (var item in items) {
			        if(item.type == "{http://ns.lyse.no/model/datalist/1.0}mccPackages" && item.assocs["lyse:mccPackagesCommissioningPackage"] == null) {
			          if (item.isContainer || item.type == "{http://www.alfresco.org/model/application/1.0}folderlink") {
			            // wrap item and determine if it is selectable in the UI
			            resultObj = 
			            { 
			                item: item
			            };
			            resultObj.selectable = isItemSelectable(item, argsSelectableType);
			            containerResults.push(resultObj);
			          } else {
			            var qnamePaths = item.qnamePath.split("/"), container;
			            if ((qnamePaths.length > 4) && (qnamePaths[2] == "st:sites"))
			            {
			              container = qnamePaths[4].substr(3);
			            }
			            // wrap result and determine if it is selectable in the UI
			            resultObj = 
			            { 
			                item: item
			            };
			            resultObj.selectable = isItemSelectable(item, argsSelectableType);
			            resultObj.container = container;
			            contentResults.push(resultObj);
			          }
			        }
			      }
			    }
			  }
			} else if(url.templateArgs.type === "mcc-signals") {
                for each (var result in childNodes) {
                    if(result.properties["name"] === "MC packages") {
                        // Get the items from the datalist
                        var items = result.childFileFolders(true, true, ignoreTypes, -1, maxResults, 0, "cm:name", true, null).getPage();
                        for each (var item in items) {
                            if(item.type == "{http://ns.lyse.no/model/datalist/1.0}mccPackages") {
                                if (item.isContainer || item.type == "{http://www.alfresco.org/model/application/1.0}folderlink") {
                                    // wrap item and determine if it is selectable in the UI
                                    resultObj =
                                        {
                                            item: item
                                        };
                                    resultObj.selectable = isItemSelectable(item, argsSelectableType);
                                    containerResults.push(resultObj);
                                } else {
                                    var qnamePaths = item.qnamePath.split("/"), container;
                                    if ((qnamePaths.length > 4) && (qnamePaths[2] == "st:sites"))
                                    {
                                        container = qnamePaths[4].substr(3);
                                    }
                                    // wrap result and determine if it is selectable in the UI
                                    resultObj =
                                        {
                                            item: item
                                        };
                                    resultObj.selectable = isItemSelectable(item, argsSelectableType);
                                    resultObj.container = container;
                                    contentResults.push(resultObj);
                                }
                            }
                        }
                    }
                }
			} else if(url.templateArgs.type === "mcc-cables") {
                for each (var result in childNodes) {
                    if(result.properties["name"] === "MC packages") {
                        // Get the items from the datalist
                        var items = result.childFileFolders(true, true, ignoreTypes, -1, maxResults, 0, "cm:name", true, null).getPage();
                        for each (var item in items) {
                            if(item.type == "{http://ns.lyse.no/model/datalist/1.0}mccPackages") {
                                if (item.isContainer || item.type == "{http://www.alfresco.org/model/application/1.0}folderlink") {
                                    // wrap item and determine if it is selectable in the UI
                                    resultObj =
                                        {
                                            item: item
                                        };
                                    resultObj.selectable = isItemSelectable(item, argsSelectableType);
                                    containerResults.push(resultObj);
                                } else {
                                    var qnamePaths = item.qnamePath.split("/"), container;
                                    if ((qnamePaths.length > 4) && (qnamePaths[2] == "st:sites"))
                                    {
                                        container = qnamePaths[4].substr(3);
                                    }
                                    // wrap result and determine if it is selectable in the UI
                                    resultObj =
                                        {
                                            item: item
                                        };
                                    resultObj.selectable = isItemSelectable(item, argsSelectableType);
                                    resultObj.container = container;
                                    contentResults.push(resultObj);
                                }
                            }
                        }
                    }
                }
			} else if(url.templateArgs.type === "epc-punch-list") {
			  // Special case, we want to fetch datalist items from another site (connected MCC site)
			  var epcSite = parent.parent;
			  if(epcSite.properties.name == "dataLists") {
			    // When in edit mode we get the datalist container as base, let's try and get the epc site.
			    epcSite = parent.parent.parent;
			  }
			  var epcSiteShortName = epcSite.properties["cm:name"];
			  var projectSite = epcSite.sourceAssocs["lysep:subProject"];
			  if(projectSite == null) {
			    projectSite = epcSite.sourceAssocs["lysep:civilProject"][0];
			  } else {
			    projectSite = epcSite.sourceAssocs["lysep:subProject"][0];
			  }
			  var mccSite = projectSite.assocs["lysep:mccProject"][0];
			  var mccSiteChildren = mccSite.children;
			  var mccDatalistContainer = null;
			  // Find datalist container
			  for each(var child in mccSiteChildren) {
			    if(child.properties.name == "dataLists"){
			      mccDatalistContainer = child;
			    }
			  }
			  childNodes = mccDatalistContainer.children;

			  for each (var result in childNodes) {
			    if(result.properties["name"] === "MC packages") {
			      // Get the items from the datalist
			      var items = result.childFileFolders(true, true, ignoreTypes, -1, maxResults, 0, "cm:name", true, null).getPage();
			      for each (var item in items) {
			        var contractor = item.assocs["lyse:mccPackagesContract"][0];
			        if(item.type == "{http://ns.lyse.no/model/datalist/1.0}mccPackages" 
			          && (contractor.properties["cm:authorityName"].indexOf(epcSiteShortName) != -1)) {
			          if (item.isContainer || item.type == "{http://www.alfresco.org/model/application/1.0}folderlink") {
			            // wrap item and determine if it is selectable in the UI
			            resultObj = 
			            { 
			                item: item
			            };
			            resultObj.selectable = isItemSelectable(item, argsSelectableType);
			            containerResults.push(resultObj);
			          } else {
			            var qnamePaths = item.qnamePath.split("/"), container;
			            if ((qnamePaths.length > 4) && (qnamePaths[2] == "st:sites"))
			            {
			              container = qnamePaths[4].substr(3);
			            }
			            // wrap result and determine if it is selectable in the UI
			            resultObj = 
			            { 
			                item: item
			            };
			            resultObj.selectable = isItemSelectable(item, argsSelectableType);
			            resultObj.container = container;
			            contentResults.push(resultObj);
			          }
			        }
			      }
			    }
			  }
			}
			results = quicksort(containerResults.concat(contentResults));
			if(argsSearchTerm) {
				results = filterResult(results, argsSearchTerm);
			}
		}

	if (logger.isLoggingEnabled())
			logger.log("Found " + results.length + " results");
	} catch (e) {
		var msg = e.message;

		if (logger.isLoggingEnabled())
			logger.log(msg);

		status.setCode(500, msg);

		return;
	}

	model.parent = parent;
	model.rootNode = rootNode;
	model.results = results;
}

/**
 * Sorts the elements based on the id with quicksort algorithm. We find the number until the character "-" and compare.
 * 
 */
function quicksort(arr) {
  //if array is empty
  if (arr.length === 0) {
    return [];
  }
  var left = [];
  var right = [];
  var pivot = arr[0];
  //go through each element in array
  for (var i = 1; i < arr.length; i++) {
    // fetch the number which we will sort on
    var first = new Number(arr[i].item.properties.name.split("-")[0]);
    var second = new Number(pivot.item.properties.name.split("-")[0]);
    //Rhino pls..
    if(first.toString() != "NaN" && second.toString() != "NaN"){
      if (first > second) {
        left.push(arr[i]);
      } else {
        right.push(arr[i]);
      }
    } else {
      return arr;
    }
  }
  return quicksort(left).concat(pivot, quicksort(right));
}

/**
 * Filters an array of scriptNodes on results.item.properties.name
 * This function is used when a user uses the search box
 * @param results
 * @param searchTerm
 * @returns
 */
function filterResult(results, searchTerm) {
	//Because of rhino, we make sure that our variables are of the type string
	var filteredResult = [];
	var searchWords = [];
	var search = String(searchTerm);
	searchWords = search.split(" ");
	for each(var result in results) {
		for each(var word in searchWords){
			word = word.replace("*",".*");
			var name = String(result.item.properties.name);
			if(name.toLowerCase().match(word.toLowerCase())){
				filteredResult.push(result);
				break;
			}
		}
	}
	return filteredResult;
}

function isItemSelectable(node, selectableType) {
	var selectable = true;

	if (selectableType !== null && selectableType !== "") {
		selectable = node.isSubType(selectableType);

		if (!selectable) {
			// the selectableType could also be an aspect,
			// if the node has that aspect it is selectable
			selectable = node.hasAspect(selectableType);
		}
	}

	return selectable;
}

/**
 * Resolve "virtual" nodeRefs, nodeRefs and xpath expressions into nodes
 *
 * @method resolveNode
 * @param reference {string} "virtual" nodeRef, nodeRef or xpath expressions
 * @return {ScriptNode|null} Node corresponding to supplied expression. Returns null if node cannot be resolved.
 */
function resolveNode(reference) {
	var node = null;
	try {
		if (reference == "alfresco://company/home") {
			node = companyhome;
		} else if (reference == "alfresco://user/home") {
			node = userhome;
		} else if (reference == "alfresco://sites/home") {
			node = companyhome.childrenByXPath("st:sites")[0];
		} else if (reference == "alfresco://shared/folder") {
			node = companyhome.childrenByXPath("app:shared")[0];
		} else if (reference.indexOf("://") > 0) {
			node = search.findNode(reference);
		} else if (reference.substring(0, 1) == "/") {
			node = search.xpathSearch(reference)[0];
		}
	} catch (e) {
		return null;
	}
	return node;
}

/**
 * Resolve "virtual" nodeRefs, nodeRefs and xpath expressions into nodes
 *
 * @method resolveDatalistNode
 * @param nodeRef {string} real nodeRef (startLocation) this is used to find stuff.
 * @return {ScriptNode|null} Node corresponding to supplied expression. Returns null if node cannot be resolved.
 */
function resolveDatalistNode(nodeRef) {
	var node = null;
	try {
		if (nodeRef.indexOf("://") > 0)
		{
			node = search.findNode(nodeRef);
			//Check if the nodes name is of dataList
			if(node.getParent().properties.name == "dataLists"){
				 node = node.getParent() 
			}
		}
	}
	catch (e) {
		return null;
	}
	return node;
}

main();