/*
 * Input is a reference to a node. This should be a listnode 
 * Some variables: 
 * args - input args (org.alfresco.repo.jscript.NativeMap)
 * url  - url data   (org.springframework.extensions.webscripts.DefaultURLModel)
 * json - there is no 'requestbody', but a json string
 */

var request=jsonUtils.toObject(json);

var data={};   // This will be returned
var state={};  // Local state

data.version="v161024a";
data.error=null;

function getIdFromNode(node){
  return node.storeType+"://"+node.storeId+"/"+node.id;
}

function dateObjectToDateString(date){
  return [
    ''+date.getFullYear(),
    ('00'+(date.getMonth()+1)).substr(-2),
    ('00'+date.getDate()).substr(-2)
  ].join('-');
};

function getNodeInfo(node){
  return {
    'type':node.type,
    'properties':node.properties
  };
}


try {
  state.editinfo=request.editinfo?request.editinfo:null;

  var currentid=''; // Used later to avoid checking against itself when a node is edited.

  // Get target datalist node.
  if(state.editinfo.status=='new'){  // ok
    // Node is given in parameters
    state.datanode=null;  // No current node yet
    state.listnodeid=request.formdata.alf_destination;
    state.listnode=search.findNode(state.listnodeid);
  }
  if(state.editinfo.status=='edit'){
    // Node should be the parent of the edited node
    currentid=state.editinfo.current_id;
    state.datanode=search.findNode(state.editinfo.current_id);  // current node
    state.listnode=state.datanode.parent;
    state.listnodeid=getIdFromNode(state.listnode);
  }

  // Get wanted new times
  state.t1=request.formdata['prop_lyse_losArrivalTimePreliminaryProp'];
  state.t2=request.formdata['prop_lyse_losArrivalTimePlannedProp'];

  data.conflicts={
    'preliminary':[],
    'planned':[]
  };

  if (state.listnode.properties['dl:dataListItemType']=='lysedl:logisticScheduleDatalist'){
    // dl:dataListItemType should be lysedl:logisticScheduleDatalist
    // in addition type should be dl:dataList, but that isn't necessary to test

    for (var i=0;i<state.listnode.children.length;i++){
      var child=state.listnode.children[i];
      var tc1=child.properties["lyse:losArrivalTimePreliminaryProp"];
      var tc2=child.properties["lyse:losArrivalTimePlannedProp"];
      //var uuid=child.properties["sys:node-uuid"];

      var check=true;
      if (currentid) {
        if (currentid == getIdFromNode(child)) check=false;
      }

      if (check) {
        if (tc1) {
          if (state.t1==dateObjectToDateString(tc1)){
            data.conflicts.preliminary.push(getNodeInfo(child));
          }
        }
        if (tc2) {
          if (state.t2==dateObjectToDateString(tc2)){
            data.conflicts.planned.push(getNodeInfo(child));
          }
        }
      }
    }
  }

}
catch(e){
  data.error=e;
}

model.result=jsonUtils.toJSONString(data);
