<import resource="classpath:/alfresco/templates/webscripts/org/alfresco/repository/forms/pickerresults.lib.js">
//@overridden /alfresco/templates/webscripts/org/alfresco/repository/forms/pickerchildren.get.js

function main()
{
   var argsFilterType = args['filterType'],
      argsSelectableType = args['selectableType'],
      argsSearchTerm = args['searchTerm'],
      argsMaxResults = args['size'],
      argsXPath = args['xpath'],
      argsRootNode = args['rootNode'],
      argsRequiredRole = args['requiredRole'],
      argsExcludeConsumers = args['excludeConsumers'],
      argsIncludeBaseGroups = args['includeBaseGroups'],
      argsExcludeContractorGroups = args['excludeContractorGroups'],
      argsExcludeContainerGroups = args['excludeContainerGroups'],
      argsIncludeOnlyCommGroups = args['includeOnlyCommGroups'],
      argsRelatedSiteTypeToFetchFrom = args['relatedSiteTypeToFetchFrom'];
      argsSiteShortName = args['siteShortName'],
      argsAddNoneOption = args['addNoneOption'],
      argsAddAnonymous = args['includeAnonymous'],
      pathElements = url.service.split("/"),
      parent = null,
      rootNode = companyhome,
      results = [],
      categoryResults = null,
      resultObj = null,
      lastPathElement = null;
   
   if (logger.isLoggingEnabled())
   {
      logger.log("children type = " + url.templateArgs.type);
      logger.log("argsSelectableType = " + argsSelectableType);
      logger.log("argsFilterType = " + argsFilterType);
      logger.log("argsSearchTerm = " + argsSearchTerm);
      logger.log("argsMaxResults = " + argsMaxResults);
      logger.log("argsXPath = " + argsXPath);
      logger.log("argsRequiredRole = " + argsRequiredRole);
      logger.log("argsExcludeConsumers = " + argsExcludeConsumers);
      logger.log("argsIncludeBaseGroups = " + argsIncludeBaseGroups);
      logger.log("argsExcludeContractorGroups = " + argsExcludeContractorGroups);
      logger.log("argsExcludeContainerGroups = " + argsExcludeContainerGroups);
      logger.log("argsIncludeOnlyCommGroups = " + argsIncludeOnlyCommGroups);
      logger.log("argsRelatedSiteTypeToFetchFrom = " + argsRelatedSiteTypeToFetchFrom);
      logger.log("argsRootNode = " + argsRootNode);
      logger.log("argsSiteShortName = " + argsSiteShortName);
      logger.log("argsAddNoneOption = " + argsAddNoneOption);
      logger.log("argsAddAnonymous = " + argsAddAnonymous);
   }
         
   try
   {
      // construct the NodeRef from the URL
      var nodeRef = url.templateArgs.store_type + "://" + url.templateArgs.store_id + "/" + url.templateArgs.id;
      
      // determine if we need to resolve the parent NodeRef
      
      if (argsXPath != null)
      {
         // resolve the provided XPath to a NodeRef
         var nodes = search.xpathSearch(argsXPath);
         if (nodes.length > 0)
         {
            nodeRef = String(nodes[0].nodeRef);
         }
      }

      // default to max of 100 results
      var maxResults = 100;
      if (argsMaxResults != null)
      {
         // force the argsMaxResults var to be treated as a number
         maxResults = parseInt(argsMaxResults, 10) || maxResults;
      }

      if (url.templateArgs.type == "authority")
      {
      	 if (argsSelectableType == "cm:person" && nodeRef!==undefined && nodeRef!==null && argsRelatedSiteTypeToFetchFrom != "none")
         {
            findRelatedSiteUsers(argsSearchTerm, maxResults, results, argsSiteShortName, argsRelatedSiteTypeToFetchFrom);
         }
 		 else if (argsSelectableType == "cm:person" && nodeRef!==undefined && nodeRef!==null)
         {
         	findSiteUsers(argsSearchTerm, maxResults, results, nodeRef, argsRequiredRole, argsExcludeConsumers, argsSiteShortName);
         	if(argsAddNoneOption == "true"){
                addDummyUser(results);
            }
         } 
    	 else if (argsSelectableType == "cm:person")
         {
            findUsers(argsSearchTerm, maxResults, results);
            if(argsAddNoneOption == "true"){
                addDummyUser(results);
            }
         }
         else if (argsSelectableType == "cm:authorityContainer" && nodeRef!==undefined && nodeRef!==null)
         {
            findSiteGroups(argsSearchTerm, results, nodeRef, argsIncludeBaseGroups, argsExcludeContractorGroups, argsExcludeContainerGroups, argsIncludeOnlyCommGroups);
            if(argsAddAnonymous == "true"){
                addAnonymous(results);
            }
         }
		 else
         {
            // combine groups and users
            findGroups(argsSearchTerm, maxResults, results);
            findUsers(argsSearchTerm, maxResults, results);
         }
      }
      
      if (logger.isLoggingEnabled())
         logger.log("Found " + results.length + " results");
   }
   catch (e)
   {
      var msg = e.message;
      
      if (logger.isLoggingEnabled())
         logger.log(msg);
      
      status.setCode(500, msg);
      
      return;
   }

   model.parent = parent;
   model.rootNode = rootNode;
   model.results = results;
}

function addAnonymous(results){
	var nodeString = groups.getGroup("anonymous").getGroupNodeRef();
    var node = search.findNode(nodeString);
    var object = createGroupResult(node);
    var item = {
	  	item: object,
	  	selectable: true
	};
    results.unshift(item);
}

function addDummyUser(results){
    // Add a dummy person, none. This needs to be removed before processing form!!
	  results.push({
	  item: {
	    typeShort: "cm:person",
	    isContainer: false,
	    properties: {
	      userName: "None",
	      name: "None"
	    },
	    displayPath: null,
	    nodeRef: "workspace://SpacesStore/NONE"
	  },
	  selectable: true
	  });
}

function isItemSelectable(node, selectableType)
{
   var selectable = true;
   
   if (selectableType !== null && selectableType !== "")
   {
      selectable = node.isSubType(selectableType);
      
      if (!selectable)
      {
         // the selectableType could also be an aspect,
         // if the node has that aspect it is selectable
         selectable = node.hasAspect(selectableType);
      }
   }
   
   return selectable;
}

/* Sort the results by case-insensitive name */
function sortByName(a, b)
{
   return (b.properties.name.toLowerCase() > a.properties.name.toLowerCase() ? -1 : 1);
}

function findUsers(filterTerm, maxResults, results)
{
   var paging = utils.createPaging(maxResults, -1);
   
   var personRefs = people.getPeoplePaging(filterTerm, paging, "lastName", true);
   
   // create person object for each result
   for each(var personRef in personRefs)
   {
      // add to results
      results.push(
      {
         item: createPersonResult(search.findNode(personRef)),
         selectable: true
      });
   }
}

function findGroups(searchTerm, maxResults, results)
{
   if (logger.isLoggingEnabled())
      logger.log("Finding groups matching pattern: " + searchTerm);
   
   var paging = utils.createPaging(maxResults, 0);
   var searchResults = groups.getGroupsInZone(searchTerm, "APP.SHARE", paging, "displayName");
   for each(var group in searchResults)
   {
      if (logger.isLoggingEnabled())
         logger.log("found group = " + group.fullName);
         
      // add to results
      results.push(
      {
         item: createGroupResult(group.groupNode),
         selectable: true 
      });
   }
   
   // sort the groups by name alphabetically
   if (results.length > 0)
   {
      results.sort(function(a, b)
      {
         return (a.item.properties.name < b.item.properties.name) ? -1 : (a.item.properties.name > b.item.properties.name) ? 1 : 0;
      });
   }
}


function findSiteUsers(filterTerm, maxResults, results, nodeRef, requiredRole, excludeConsumers, siteShortName)
{
   var paging = utils.createPaging(maxResults, -1);

   if(siteShortName == null){
   	var node = search.findNode(nodeRef);
   
   	if(node == null) {
		   throw new Exception("Could not find nodeRef for " + nodeRef);
   	}

       //Get the site where the start location node belongs
       siteShortName = node.siteShortName;
   }
   var ctx = Packages.org.springframework. web.context.ContextLoader.getCurrentWebApplicationContext();

   var realSiteService = ctx.getBean("SiteService");
   var projectService = ctx.getBean("lyse.projectService");
   //Use site service instead since we are only interested in finding site limited users here
   filterTerm = filterTerm + "*";
   var personObjs = projectService.listMembersInfo(siteShortName, filterTerm, requiredRole, maxResults, true);


   logger.log("Found " + personObjs.size() + " site users applying filter " + filterTerm);

   // create person object for each result
   for (var i=0;i<personObjs.size();i++) {
      var personObj = personObjs.get(i);
      
      // https://redmine.redpill-linpro.com/issues/35272
      // Exclude observers (SiteConsumer) by parameter in picker. 
      if (!(excludeConsumers == "true" && personObj.memberRole == "SiteConsumer")){
	      var person = people.getPerson(personObj.memberName);
	      results.push(
	      {
	         item: createPersonResult(person),
	         selectable: true
	      });
      }
   }
   if (results.length > 0)
   {
      results.sort(function(a, b)
      {
         return (a.item.properties.name < b.item.properties.name) ? -1 : (a.item.properties.name > b.item.properties.name) ? 1 : 0;
      });
   }

   logger.log("FindSiteUsers done");
}

function findRelatedSiteUsers(filterTerm, maxResults, results, shortName, argsRelatedSiteTypeToFetchFrom)
{
   var paging = utils.createPaging(maxResults, -1);

   var ctx = Packages.org.springframework. web.context.ContextLoader.getCurrentWebApplicationContext();

   var projectService = ctx.getBean("lyse.projectService");


   //Use site service instead since we are only interested in finding site limited users here
   filterTerm = filterTerm + "*";
   var personObjs = projectService.listUniqueUsersForRelatedSiteType(shortName, argsRelatedSiteTypeToFetchFrom, filterTerm, maxResults);


   logger.log("Found " + personObjs.size() + " site users applying filter " + filterTerm);

   // create person object for each result
   for (var i=0;i<personObjs.size();i++) {
      var personObj = personObjs.get(i);
      var person = people.getPerson(personObj.memberName);
      results.push(
	  {
	     item: createPersonResult(person),
	     selectable: true
	  });
   }

   logger.log("FindRelatedSiteUsers done");
}

function findInterfaceSiteUsers(filterTerm, maxResults, results, siteShortName)
{
   var paging = utils.createPaging(maxResults, -1);

   var ctx = Packages.org.springframework. web.context.ContextLoader.getCurrentWebApplicationContext();

   // Lets find all epc-sites connected to this interface site
   var projectService = ctx.getBean("lyse.projectService");


   //Use site service instead since we are only interested in finding site limited users here
   filterTerm = filterTerm + "*";
   var personObjs = projectService.listUniqueEPCUsersForInterfaceSite(siteShortName, filterTerm, maxResults);


   logger.log("Found " + personObjs.size() + " site users applying filter " + filterTerm);

   // create person object for each result
   for (var i=0;i<personObjs.size();i++) {
      var personObj = personObjs.get(i);
      var person = people.getPerson(personObj.memberName);
      results.push(
	  {
	     item: createPersonResult(person),
	     selectable: true
	  });
   }

   logger.log("FindInterfaceSiteUsers done");
}


function findSiteGroups(filterTerm, results, nodeRef, argsIncludeBaseGroups, argsExcludeContractorGroups, argsExcludeContainerGroups, argsIncludeOnlyCommGroups) {
    var node = search.findNode(nodeRef);

    if(node == null) {
        throw new Exception("Could not find nodeRef for " + nodeRef);
    }

    // Get the site where the start location node belongs
    var siteShortName = node.siteShortName;
    var ctx = Packages.org.springframework. web.context.ContextLoader.getCurrentWebApplicationContext();
    var realSiteService = ctx.getBean("SiteService");
    // Find the site group
    var siteGroup = realSiteService.getSiteGroup(siteShortName);
    var projectService = ctx.getBean("lyse.projectService");
    //var siteGroups = projectService.getCompanyGroups(siteShortName);
    //siteGroups.addAll(projectService.getContractorGroups(siteShortName));

    var siteGroups = groups.getGroupForFullAuthorityName(siteGroup).getAllGroups();

    if (logger.isLoggingEnabled()) {
        logger.log("projectService = " + projectService);
        logger.log("siteGroup = " + siteGroup);
        logger.log("site groups = " + siteGroups);
    }

    for each(var group in siteGroups)
    {
        if (logger.isLoggingEnabled())
            logger.log("found grupp = '" + group.fullName + "'");
        // add to results
        // TODO also apply search filter entered by user!!
        var ignorePattern;
        var includeOnlyCommGroups;
        if(argsExcludeContractorGroups=="true" && argsIncludeBaseGroups=="true")
        {
          ignorePattern = new RegExp(/\_(SiteCollaborator|SiteContributor|SiteManager|SiteConsumer|SiteCompanyObs|SiteContractorObs|SiteHSEContractor)$/g);
        }
        else if(argsIncludeBaseGroups=="true"){
             ignorePattern = new RegExp(/\_(SiteCollaborator|SiteContributor|SiteManager|SiteConsumer|SiteCompanyObs|SiteContractorObs)$/g);
        }else if(argsExcludeContractorGroups=="true"){
             ignorePattern = new RegExp(/\_(SiteCollaborator|SiteContributor|SiteManager|SiteConsumer|SiteCompanyObs|SiteContractorObs|SiteCompanyBase|SiteContractorBase|SiteHSEContractor)$/g);
        }else if(argsExcludeContainerGroups=="true"){
             ignorePattern = new RegExp(/\_(SiteCollaborator|SiteContributor|SiteManager|SiteConsumer|SiteCompanyObs|SiteContractorObs|SiteMCCContractors|SiteMCCContractorMC|SiteMCCContractorObs|SiteMCCCompanyObs)$/g);
        }else {
             ignorePattern = new RegExp(/\_(SiteCollaborator|SiteContributor|SiteManager|SiteConsumer|SiteCompanyObs|SiteContractorObs|SiteCompanyBase|SiteContractorBase|SiteHSEContractor)$/g);
        }

         if(argsIncludeOnlyCommGroups=="true") {
        	includeOnlyCommGroups = new RegExp(/\_(SiteCompanyComm|SiteContractorComm)$/g);
        }

        var searchTermPattern = new RegExp(filterTerm == "*" ? "" : filterTerm, "gi");

        if(argsIncludeOnlyCommGroups=="true") {
            if(includeOnlyCommGroups.test(group.fullName)) {
        	    results.push(
                {
                    item: createGroupResult(group.groupNode),
                    selectable: true
                });
            }
        } else if (false == ignorePattern.test(group.fullName) && searchTermPattern.test(group.fullName)) {
            results.push(
                {
                    item: createGroupResult(group.groupNode),
                    selectable: true
                });
        }
    }

}

main();