<import resource="classpath:/alfresco/templates/webscripts/org/alfresco/repository/site/sites.post.json.js">
<import resource="classpath:/alfresco/extension/templates/webscripts/no/lyse/alfresco/repo/project/project.lib.js">

function DuplicateNameException(message) {
   this.message = message;
   this.code = status.STATUS_BAD_REQUEST
   this.name = "DuplicateNameException";
}

function addProjectMetadata() {
  var nodeRef = model.site.node.nodeRef;
  var site = search.findNode(nodeRef);

  logger.log("Adding project metadata to site "+json.get("shortName")+" ("+nodeRef+")");
  //The following two properties are copied from the default form fields
  var projectName = getJsonValueOrNull(site, json, "title", false);
  var projectDescription = getJsonValueOrNull(site, json, "description", false);
  site.properties["lysep:projectName"] = projectName;
  site.properties["lysep:projectDescription"] = projectDescription;
  site.save();
  
  
  //Lookup parent project
  var parentSiteName = getJsonValueOrNull(site, json, "subProject", false); 
  logger.log("parentSiteName=" + parentSiteName);
  if (parentSiteName!=null) {
    //var parentProject = search.findNode(parentProjectNodeRef);
	var parentSite = siteService.getSite(parentSiteName);
	var parentProject = parentSite.node;
	var parentProjectNodeRef = parentProject.nodeRef;
	
	// depending on site-preset add correct association
	if (model.site.sitePreset == 'interface-site'){
	    logger.log("Adding interface assoc Parent project -> project: " + parentProject.properties["cm:name"] + " ("+parentProjectNodeRef+") ->"+ json.get("shortName")+" ("+ nodeRef +")");
	    parentProject.createAssociation(site, "lysep:interfaceProject");
	}else if(model.site.sitePreset == 'mcc-site'){
      logger.log("Adding mcc assoc Parent project -> project: " + parentProject.properties["cm:name"] + " ("+parentProjectNodeRef+") ->"+ json.get("shortName")+" ("+ nodeRef +")");
      parentProject.createAssociation(site, "lysep:mccProject");
	}else if(model.site.sitePreset == 'civil-site'){
      logger.log("Adding mcc assoc Parent project -> project: " + parentProject.properties["cm:name"] + " ("+parentProjectNodeRef+") ->"+ json.get("shortName")+" ("+ nodeRef +")");
      parentProject.createAssociation(site, "lysep:civilProject");
	}else{
	    logger.log("Adding contractor assoc Parent project -> project: " + parentProject.properties["cm:name"] + " ("+parentProjectNodeRef+") ->"+ json.get("shortName")+" ("+ nodeRef +")");
	    parentProject.createAssociation(site, "lysep:subProject");
	}
    site.save();
  }  
}

//If duplicate site name is found rollback creation of site
function checkForDuplicateName() {
  var query = "TYPE:\"lysep:project\" AND @cm\\:title:\""+ json.get("title") +"\"";
  logger.log("Query for finding dupliate site names: "+query)
  var nodes = search.luceneSearch(query);
  if (nodes.length>1) { //We expect one site to exist (this one)
    logger.log("Detected duplicate site title. Rolling back creation of site "+json.get("shortName"));
    var site = siteService.getSite(json.get("shortName"));
    if (site == null)
    {
      // Return 404
      status.setCode(404, "Created project site " + shortName + " does not exist");
      return;
    }

    // Delete the site
    site.deleteSite();
    return true;
  }
  return false;
}

if (model.site!=undefined && model.site!=null) {
  if (checkForDuplicateName()) {
    status.setCode(status.STATUS_BAD_REQUEST, "error.duplicateName");
  } else {
   addProjectMetadata();
  }
}