<#import "/org/alfresco/slingshot/datalists/item.lib.ftl" as itemLib />
<#escape x as jsonUtils.encodeJSONString(x)>
{
   "totalRecords": ${data.paging.totalRecords?c},
   "startIndex": ${data.paging.startIndex?c},
<#if data.paging.totalRecordsUpper??>
	"totalRecordsUpper": ${data.paging.totalRecordsUpper?c},
</#if>
   "metadata":
   {
      "parent":
      {
      <#if data.parent??>
         <#assign parentNode = data.parent.node>
         "nodeRef": "${parentNode.nodeRef!}",
         "permissions":
         {
            "userAccess":
            {
            <#list data.parent.userAccess?keys as perm>
               <#if data.parent.userAccess[perm]?is_boolean>
               "${perm?string}": ${data.parent.userAccess[perm]?string}<#if perm_has_next>,</#if>
               </#if>
            </#list>
            }
         }
      </#if>
      }
   },
   "items":
   [
      <#list data.items as item>
      {
         <@itemLib.itemJSON item />,
         <#-- Start Lyse modification -->
         "workflowTasks":
         [
            <#list item.workflowTasks as workflowTask>
               {
                  "id": "${workflowTask.id?js_string}",
                  "name": "${workflowTask.name?js_string}",
                  "title": "${workflowTask.title?js_string}",
                  "description": "${workflowTask.description?js_string}",
                  "isComplete": "${workflowTask.complete?string}",
                  "isPooled": "${workflowTask.pooled?string}",
                  "workflowId": "${workflowTask.workflowId!}" <#-- NOTE! This property is added by no.lyse.alfresco.repo.script.ScriptLyseWorkflowService.ExtendedJscriptWorkflowTask! -->
               }
               <#if workflowTask_has_next>,</#if>
            </#list>
         ],
         "responsibles":
         [
           <#if item.responsibles??>
              <#list item.responsibles as responsible>
                {
                  "name": "${responsible.label?js_string}"
                }
                <#if responsible_has_next>,</#if>
              </#list>
           </#if>
         ]
         <#-- End Lyse modification -->
      }<#if item_has_next>,</#if>
      </#list>
   ]
}
</#escape>