<import resource="classpath:alfresco/extension/templates/webscripts/org/alfresco/slingshot/datalists/evaluator.lib.js">
<import resource="classpath:alfresco/extension/templates/webscripts/org/alfresco/slingshot/datalists/filters.lib.js">
<import resource="classpath:alfresco/extension/templates/webscripts/org/alfresco/slingshot/datalists/parse-args.lib.js">

//@overridden projects/remote-api/config/alfresco/templates/webscripts/org/alfresco/slingshot/datalists/data.post.json.js
const REQUEST_MAX = 5000;
const userPagedSearch = true;
//const allFilterUseSearch = true; //this works faster for larger lists

/**
 * Copyright (C) 2005-2010 Alfresco Software Limited.
 *
 * This file is part of Alfresco
 *
 * Alfresco is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Alfresco is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Alfresco. If not, see <http://www.gnu.org/licenses/>.
 */


// var ESCAPES = [[/&/g, "&amp;"], [/</g, "&lt;"], [/>/g, "&gt;"], [/"/g, "&quot;"]]

function escape(value) {
	return value.replace('"','');
	/*
	var escaped = value;
	for(var item in ESCAPES)
	    escaped = escaped.replace(ESCAPES[item][0], ESCAPES[item][1]);
	return escaped;
	*/
}

function filterRange(array, range) {
	logger.log("Applying " + range.prop + " range filter " + range.min + " <= x <= " + range.max);
	var filtered = [];
	for (var i=0; i<array.length; i++) {
		obj = array[i];
		logger.log(obj.properties[range.prop]);
		var minOk = !range.min || (obj.properties[range.prop] && (range.min.getTime() <= obj.properties[range.prop].getTime()));
		var maxOk = !range.max || (obj.properties[range.prop] && (obj.properties[range.prop].getTime() <= range.max.getTime()));
		if (minOk && maxOk) {
			filtered.push(obj);
		}
	}
	
	return filtered;
}

function xPathFilterQuery(filterData) {
	var rangeFilters = [];
	var fieldQuery = [];
	var fieldNamesIterator = filterData.getFieldNames().iterator();
	for ( ; fieldNamesIterator.hasNext(); ){
		var fieldName = fieldNamesIterator.next();
		if (filterData.getFieldData(fieldName).getValue()!= ""){
			var propName = fieldName.replace("prop_","").replace("_",":");
	    	var value = new String(filterData.getFieldData(fieldName).getValue());
	    	if (propName.indexOf("-date-range") > 0){
	    		propName = propName.replace("-date-range","");
	    		rf = { prop: propName };
				var dates = value.split("TO");
				if (dates[0] == ""){
					rf.max =  utils.fromISO8601(dates[1]);
				}
				else if (dates[1] == ""){
					rf.min = utils.fromISO8601(dates[0]);
				}else{
					rf.min =  utils.fromISO8601(dates[0]);
					rf.max = utils.fromISO8601(dates[1]);
				}
	    		rangeFilters.push(rf);
	    	}
	    	else if (propName.indexOf("Priority") > 0 || propName.indexOf("Status") > 0){
				var values = value.split(",");
				var escaped = [];
				for (var i=0;i<values.length;i++) {
					escaped.push('"' + escape(values[i]) + '"');
				}
				fieldQuery.push('(@' + propName + '=' + escaped.join(' or @' + propName + '=') + ')');
	    	} 
	    	else{
	    		fieldQuery.push("(like(@" + propName + ',"*' + escape(value) + '*"))');
	    	}
	    	
		}
	}
	return {
		rangeFilters : rangeFilters,
		propQuery : "[" + fieldQuery.join(" and ") + "]" 
	}
}

/**
 * Main entry point: Return data list with properties being supplied in POSTed arguments
 *
 * @method getData
 */
function getData()
{
   // Use helper function to get the arguments
   var parsedArgs = ParseArgs.getParsedArgs();
   if (parsedArgs === null)
   {
      return;
   }

   var fields = null;
   // Extract fields (if given)
   if (json.has("fields"))
   {
      // Convert the JSONArray object into a native JavaScript array
      fields = [];
      var jsonFields = json.get("fields"),
         numFields = jsonFields.length();
      
      for (count = 0; count < numFields; count++)
      {
         fields.push(jsonFields.get(count).replaceFirst("_", ":"));
      }
   }

   // Try to find a filter query based on the passed-in arguments
   var filter = parsedArgs.filter,
      allNodes = [], 
      node,
      items = [],
      totalItems,
      requestTotalCountMax = 0;
   
   var 	skip = 0,
   		size = 100,
   		total = 0,
   		page = 1,
   		countTotal;
   
   
   if (json.has("size"))
   {
	   size = json.get("size");
	   
      if (json.has("page"))
      {
    	  page = json.get("page");
          skip = (page - 1) * size;
      }
   }
   
   requestTotalCountMax = skip + REQUEST_MAX;
   
   if (json.has("total"))
   {
	   total = json.get("total");
	  
	   if (0 < total  && total < REQUEST_MAX) {
		   requestTotalCountMax = total + 10; // add for growth
	   } // else we do not know use absolute max: requestTotalCountMax
   }
   var sortAsc = false;
   var sortField = "dl:itemId";

   if (json.has("filter")) {
	   var filterJson = json.get("filter");
	  
	   if (filterJson.has("sortField")) {
		  var sortField = filterJson.get("sortField").replace("assoc_","").replace("prop_","").replace("_",":");
	   } 
	   if (filterJson.has("sortAsc")) {
		  var sortAsc = filterJson.get("sortAsc");
	   } 
   }


   var parentNode = parsedArgs.listNode;
	var timeBefore = new Date().getTime();
   if ((parentNode != null) && (filter == null || filter.filterId == "" || filter.filterId == "all"))
   {
         var pagedResult = parentNode.childFileFolders(true, false, Filters.IGNORED_TYPES, skip, size, requestTotalCountMax, sortField, sortAsc, null);
         allNodes = pagedResult.page;
         totalItems = pagedResult.totalResultCountUpper;
   }
   else    
   {
      var filterParams = Filters.getFilterParams(filter, parsedArgs);
      var query = filterParams.query;
      // Query the nodes - passing in default sort and result limit parameters
      if (query !== "")
      {
    	  var queryTotal = pagedSearch.countQuery(null, query, filterParams.language).totalResultCountUpper;
    	  
    	  var sortObj = [{
    		                     column: "@" + sortField,
    		                     ascending: sortAsc
    		                  }];
    	  
    	  var queryObj = {
    	            query: query,
    	            language: filterParams.language,
    				page:
    				{
    					skipCount: skip,
    					pageSize: size, 
    					maxItems: requestTotalCountMax
    				},
    	            sort: sortObj,
    	            templates: filterParams.templates,
    	            namespace: (filterParams.namespace ? filterParams.namespace : null)
    	         };
    	  
 /*         var queryDef = {
             query: query,
             language: filterParams.language,
             page: {maxItems: -1, skipCount: skip},
             templates: filterParams.templates,
             onerror: "no-results",
             sort: sortObj 
          };*/

          
    	  if (userPagedSearch) {
    		  pagedResult = pagedSearch.pagedQuery(queryObj);
    		  //pagedResult = search.query(queryDef);
    	  } 
    	  else 
    	  {
    		  allNodes = search.query(queryObj);
    	  }
       
      }
      if (pagedResult) {
	      allNodes = pagedResult.page;
	      totalItems = pagedResult.totalResultCountUpper;
		  //allNodes = allNodes.slice(0, size);
      }
      else 
	  {
    	  totalItems = skip + allNodes.length;
		  allNodes = allNodes.slice(0, size);
	  }
      

   }
   
   var paging = {
		   totalRecords: (0 < countTotal ? (0 < queryTotal ? queryTotal : countTotal) : totalItems),
		   startIndex: skip,
   }

   if (paging.totalRecords == (skip + REQUEST_MAX)) {
	   paging.totalRecordsUpper = true;
   }
	logger.log("Time for query and paging: ");
	logger.log(new Date().getTime() - timeBefore);

	var timeBefore = new Date().getTime();
   if (allNodes.length > 0)
   {
      for each (node in allNodes)
      {
         try
         {
        	 if (String(filter.filterId)=="activeIssuesContractor"){
        		 if(lyseWorkflowService.hasRunningWorkflowForRole("contractor", node)){
        			 items.push(Evaluator.run(node, fields));
        		 }
        	 }else if (String(filter.filterId)=="activeIssuesCompany"){
        		 if(lyseWorkflowService.hasRunningWorkflowForRole("company", node)){
        			 items.push(Evaluator.run(node, fields));
        		 }
        	 }else{
        		 items.push(Evaluator.run(node, fields));
        	 }
         }
         catch(e) {}
      }
   }
   logger.log("Time for evaluation: ");
	logger.log(new Date().getTime() - timeBefore);

   return (
   {
      fields: fields,
      paging: paging,
      parent:
      {
         node: parsedArgs.listNode,
         userAccess:
         {
            create: siteHelper.hasCreateDatalistItemPermission(parsedArgs.listNode),
            createVO: parsedArgs.listNode.hasPermission("CreateChildren") && siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.listNode), "SiteCompanyRep"),
            createVOR: parsedArgs.listNode.hasPermission("CreateChildren") && siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.listNode), "SiteContractorRep"),
            createCivilVO: parsedArgs.listNode.hasPermission("CreateChildren") && siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.listNode), "SiteCompanyRep"),
            createCivilVOR: parsedArgs.listNode.hasPermission("CreateChildren") && siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.listNode), "SiteContractorRep"),
            createNCR: parsedArgs.listNode.hasPermission("CreateChildren") && (siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.listNode), "SiteContractorRep")||siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.listNode), "SiteContractor")),
            createMilestone: parsedArgs.listNode.hasPermission("CreateChildren") && (siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.listNode), "SiteCompanyRep")||siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.listNode), "SiteCompany")),
			createCivilMilestone: parsedArgs.listNode.hasPermission("CreateChildren") && (siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.listNode), "SiteCompanyRep")||siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.listNode), "SiteCompany"))
         }
      },
      items: items
   });
}

/**
 * Processes the search results.
 * 
 * @return the final search results object
 */
function processResults(nodes, maxPageResults, startIndex, rootNode)
{
   var results = [];
   
   if (logger.isLoggingEnabled())
      logger.log("Processing resultset of length: " + nodes.length);
   
   startIndex = startIndex ? startIndex : 0;
   for (var i = 0, j = nodes.length; i < j; i++)
   {
	   results.push(nodes[i]);
   }
   
   return (
   {
      paging:
      
      {
         totalRecords: results.length,
         totalRecordsUpper: nodes.length,
         startIndex: startIndex
      },
      items: results
   });
}


model.data = getData();