<import resource="classpath:alfresco/extension/templates/webscripts/org/alfresco/slingshot/datalists/parse-args.lib.js">

//@overridden projects/remote-api/config/alfresco/templates/webscripts/org/alfresco/slingshot/datalists/lists.get.json.js

/**
 * Copyright (C) 2005-2010 Alfresco Software Limited.
 *
 * This file is part of Alfresco
 *
 * Alfresco is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Alfresco is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Alfresco. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Main entry point: Return list of Data Lists
 *
 * @method getDataLists
 */
function getDataLists()
{
   // Use helper function to get the arguments
   var parsedArgs = ParseArgs.getParsedArgs();
   if (parsedArgs === null)
   {
      return;
   }
   
   return (
   {
      container: parsedArgs.rootNode,
      lists: removeHidden(parsedArgs.rootNode.childAssocs["cm:contains"]) || []
   });
}

function isProjectManager()
{
   // Use helper function to get the arguments
   var parsedArgs = ParseArgs.getParsedArgs();
   if (parsedArgs === null)
   {
      return;
   }
   
   return 	siteHelper.hasSiteRole(siteHelper.getSiteShortName(parsedArgs.rootNode), "SiteProjectAdministrator");
}

function removeHidden(lists){
	if (lists != undefined && lists != null){
		var i = lists.length;
		while (i--){
			var node = lists[i];
			if (node.hasAspect("sys:hidden")){
				lists.splice(i, 1);
			}
		}
	}
	return lists;
}

/* Sort the results by case-insensitive title */
function sortByTitle(a, b)
{
   return (b.properties["cm:title"].toLowerCase() > a.properties["cm:title"].toLowerCase() ? -1 : 1);
}

datalists = getDataLists();

datalists.lists.sort(sortByTitle);

model.datalists = datalists;
model.isProjectAdmin = isProjectManager();
