<?xml version="1.0" encoding="UTF-8"?>
<fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">
    <fo:layout-master-set>
        <fo:simple-page-master master-name="A4"
                               page-height="29.7cm"
                               page-width="21cm"
                               margin-top="1cm"
                               margin-bottom="2cm"
                               margin-left="2.5cm"
                               margin-right="2.5cm">
            <fo:region-body margin-top="20mm" column-count="1" column-gap="0.50in" overflow="auto"/>
            <fo:region-before region-name="header" extent="10mm"/>
            <fo:region-after extent="20mm"/>
        </fo:simple-page-master>
    </fo:layout-master-set>

    <fo:page-sequence master-reference="A4">
        <fo:static-content flow-name="header">

            <fo:block-container absolute-position="absolute" left="120mm" top="3mm">
                <fo:block>
                    <fo:inline font-family="Helvetica" font-size="10pt" font-weight="bold">PAGE &#xA0;</fo:inline>
                    <fo:inline font-family="Helvetica" font-size="10pt">
                        <fo:page-number/>
                        of
                        <fo:page-number-citation ref-id="endofdoc"/>
                    </fo:inline>
                </fo:block>
            </fo:block-container>
            <fo:block-container absolute-position="absolute" left="0mm" top="0mm">
                <fo:block>
                    <fo:external-graphic src="url(${templateHelper.getLogoDirectoryPath()}logo_rgb.png)" content-height="scale-to-fit" height="0.50in" content-width="0.50in"/>
                </fo:block>
            </fo:block-container>

        </fo:static-content>
        <fo:flow flow-name="xsl-region-body">
            <fo:block font-family="Helvetica" font-size="14pt" font-weight="bold" space-before="5mm" line-height="14pt" space-after="5mm" text-align-last="justify">
                Agenda
                <fo:leader leader-pattern="space"/>
            ${headerProperties.siteName?xml}
            </fo:block>
            <fo:block font-family="Helvetica" font-size="12pt" font-weight="bold" space-before="5mm" line-height="12pt" space-after="5mm">
            ${headerProperties.heading?xml}
            </fo:block>
            <fo:block font-family="Helvetica" font-size="12pt">
                <fo:inline font-weight="bold">Monthly meeting: </fo:inline>
                <fo:inline>${headerProperties.meetingNumber?xml}</fo:inline>
            </fo:block>
            <fo:block font-family="Helvetica" font-size="12pt">
                <fo:inline font-weight="bold">Meeting date: </fo:inline>
                <fo:inline>${headerProperties.meetingDate?xml}</fo:inline>
            </fo:block>
            <fo:block font-family="Helvetica" font-size="12pt">
                <fo:inline font-weight="bold">Location: </fo:inline>
                <fo:inline>${headerProperties.meetingLocation?xml}</fo:inline>
            </fo:block>
            <fo:block font-family="Helvetica" font-size="12pt">
                <fo:leader/>
            </fo:block>
            <fo:block font-family="Helvetica" font-size="12pt">
                <fo:inline font-weight="bold">Participants: </fo:inline>
                <fo:inline>${headerProperties.projectParticipants?xml}<#if headerProperties.externalParticipants?has_content>,</#if> ${headerProperties.externalParticipants?xml}</fo:inline>
            </fo:block>
            <fo:block font-family="Helvetica" font-size="12pt">
                <fo:leader/>
            </fo:block>
            <fo:block font-family="Helvetica" font-size="12pt">
                <fo:inline font-weight="bold">Copy to: </fo:inline>
                <fo:inline>${headerProperties.copyTo?xml}</fo:inline>
            </fo:block>
            <#if headerProperties.meetingText??>
                <fo:block space-after="5mm" linefeed-treatment="preserve">
                    <fo:inline font-size="12pt" font-weight="bold">Meeting text: </fo:inline>
                    <fo:inline font-size="10pt">${headerProperties.meetingText?xml}</fo:inline>
                </fo:block>
            </#if>
            <fo:table table-layout="fixed" width="100%" margin-top="10mm" border-collapse="separate" border-separation="3pt">
                <fo:table-column column-width="60mm"/>
                <fo:table-column column-width="auto"/>

                <fo:table-body start-indent="0pt">

                <#list items as row>
                    <fo:table-row>
                        <fo:table-cell number-columns-spanned="2" border-top="solid 2pt black">
                            <fo:block linefeed-treatment="preserve">
                                <fo:block font-family="Helvetica" font-size="10pt" font-weight="bold">${row.properties["lysedl:interfaceActionTitle"]?xml}</fo:block>
                            </fo:block>
                        </fo:table-cell>
                    </fo:table-row>
                    <fo:table-row>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt" font-weight="bold">Id:</fo:block>
                        </fo:table-cell>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt">
                                <#if row.properties["lysedl:workflowId"]??>
                                    <fo:basic-link
                                            external-destination="url('${headerProperties.datalistUrl}?workflowId=${row.properties["lysedl:workflowId"]}')"
                                            color="blue" text-decoration="underline">
                                    ${row.properties["dl:itemId"]?xml}
                                    </fo:basic-link>
                                <#else>
                                    <fo:basic-link
                                            external-destination="url('${headerProperties.datalistUrl}?nodeRef=${row.nodeRef}')"
                                            color="blue" text-decoration="underline">
                                    ${row.properties["dl:itemId"]?xml}
                                    </fo:basic-link>
                                </#if>
                            </fo:block>
                        </fo:table-cell>
                    </fo:table-row>
                    <fo:table-row>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt" font-weight="bold">Purpose:</fo:block>
                        </fo:table-cell>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt"><#if row.properties["lysedl:interfaceActionPurpose"]??>${templateHelper.getConstraintLabel(row.properties["lysedl:interfaceActionPurpose"], "interfaceActionPurpose")?xml}</#if></fo:block>
                        </fo:table-cell>
                    </fo:table-row>
                    <fo:table-row>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt" font-weight="bold">Area:</fo:block>
                        </fo:table-cell>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt">${row.properties["lysedl:interfaceActionArea"]?xml}</fo:block>
                        </fo:table-cell>
                    </fo:table-row>
                    <fo:table-row>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt" font-weight="bold">Responsible groups:</fo:block>
                        </fo:table-cell>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt">
                                <#if row.properties["lysedl:newResponsibleGroupsAsText"]??>
                                    ${row.properties["lysedl:newResponsibleGroupsAsText"]?xml}
                                </#if>
                            </fo:block>
                        </fo:table-cell>
                    </fo:table-row>
                    <fo:table-row>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt" font-weight="bold">Due date:</fo:block>
                        </fo:table-cell>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt"><#if row.properties["lysedl:interfaceActionDueDate"]??>${row.properties["lysedl:interfaceActionDueDate"]?string('yyyy-MM-dd')}</#if>
                            </fo:block>
                        </fo:table-cell>
                    </fo:table-row>
                    <fo:table-row>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt" font-weight="bold">Status:</fo:block>
                        </fo:table-cell>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt">${templateHelper.getConstraintLabel(row.properties["lysedl:interfaceActionStatus"], "interfaceActionStatus")?xml}</fo:block>
                        </fo:table-cell>
                    </fo:table-row>
                    <fo:table-row>
                        <fo:table-cell>
                            <fo:block font-family="Helvetica" font-size="10pt" font-weight="bold">Status/Next action:</fo:block>
                        </fo:table-cell>
                    </fo:table-row>
                    <fo:table-row>
                        <fo:table-cell number-columns-spanned="2">
                            <fo:block font-family="Helvetica" font-size="10pt"><#if row.properties["lysedl:interfaceActionAction"]??>${templateHelper.htmlToPlainText(row.properties["lysedl:interfaceActionAction"])}</#if></fo:block>
                        </fo:table-cell>
                    </fo:table-row>
                </#list>
                </fo:table-body>
            </fo:table>
            <fo:block id="endofdoc" color="white">
                <fo:page-number/>
            </fo:block>
        </fo:flow>
    </fo:page-sequence>
</fo:root>