<import resource="classpath:/alfresco/templates/webscripts/org/alfresco/repository/requestutils.lib.js">
<import resource="classpath:/alfresco/templates/webscripts/org/alfresco/repository/generic-paged-results.lib.js">
<import resource="classpath:alfresco/templates/webscripts/org/redpill/comments/comments.lib.js">

function getCommentAndRepliesData(node) {
    // Get the original comment data
    var commentData = getCommentData(node);
    // Add replies recursively
    commentData.replies = [];
    var replies = node.sourceAssocs["cm:references"];
    if (replies) for (i = 0; i < replies.length; i++) {
        if (replies[i].hasPermission("Read")) {
            commentData.replies.push(getCommentAndRepliesData(replies[i]));
        }
    }
    return commentData;
}

/**
 * Get all comments for a node
 */
function getCommentsList(node, index, count, reverse, startDate, endDate, commentTopic)
{
   var nodes = [];

  // Only get the "root" comments, not the replies
  for each (comment in getComments(node, commentTopic)) {
    if (!comment.assocs["cm:references"]){
      // Only add comments that are within the time span
      if(startDate && endDate) {
        if(startDate < comment.properties.created.getTime() && comment.properties.created.getTime() < endDate) {
          nodes.push(comment);
        }
      }else {
        nodes.push(comment);
      }
    }
  }
   // If they want newest first, sort that before we page it
   if (reverse == "true" && nodes.length > 0)
   {
      // Don't want to mutate the result.items array. Therefore we use slice(0) to get a (shallow) copy of it.
      nodes = nodes.slice(0).reverse();
   }

   // Now do any paging that's required
   return getPagedResultsData(nodes, index, count, getCommentAndRepliesData);
}

function main()
{
   // get requested node
   var node = getRequestNode();
   if (status.getCode() != status.STATUS_OK)
   {
      return;
   }

   // process additional parameters
   var reverse = args["reverse"] != undefined ? args["reverse"] : "false";
   var commentTopic = args["commentTopic"] != undefined ? args["commentTopic"] : "Comments";
   var index = args["startIndex"] != undefined ? parseInt(args["startIndex"]) : 0;
   var count = args["pageSize"] != undefined ? parseInt(args["pageSize"]) : 10;
   var startDate = args["startDate"] != undefined ? parseInt(args["startDate"]) : null;
   var endDate = args["endDate"] != undefined ? parseInt(args["endDate"]) : null;

  model.data = getCommentsList(node, index, count, reverse, startDate, endDate, commentTopic);
  model.node = node;
}

main();
